#include "generic.h"
#include "vektorr3.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>
#include "SDL/SDL_gfxPrimitives.h"

const int NO_CURVES  =  4;
const int NO_KNOTS   =  4;
const int SURF_RES_X = 25;
const int SURF_RES_Y = 25;

VektorR3 Knot[NO_CURVES][NO_KNOTS];

int      window_width, window_height;

double sqr(double v)
{
  return v*v;
} // sqr

inline void SetPixelColor(SDL_Surface *screen, int x, int y, unsigned char red, unsigned char green, unsigned char blue)
{
  if(x < 0) return;
  if(y < 0) return;

  if(x >= window_width) return;
  if(y >= window_height) return;

  ((unsigned char*)(screen->pixels))[x*3+0 + y*screen->pitch] = red;
  ((unsigned char*)(screen->pixels))[x*3+1 + y*screen->pitch] = green;
  ((unsigned char*)(screen->pixels))[x*3+2 + y*screen->pitch] = blue;
} // SetPixelColor

inline void SetPixel(SDL_Surface* screen, int x, int y)
{
  SetPixelColor(screen, x, y, 255, 255, 255);
} // SetPixel

VektorR3 CalcHermit(VektorR3* P, double t)
{

} // CalcHermit

VektorR3 Rotate(VektorR3 point, double alfa, double beta)
{
  VektorR3 P1, P2;

  P1 = point; // rotation around X-axis does not yet take place
  P2 = P1;    // rotation around Y-axis

  return P2;
} // Rotate

void DisplayHermit(SDL_Surface *screen, double alfa, double beta, long color)
{
  VektorR3 P[4], display_point;
  VektorR3 point;

  for(double s = 0.0; s <= 1.0; s += 1.0/SURF_RES_Y) {

    // Calculate the four knots which define the curve in the inner loop

    ...
    
    for(double t = 0.0; t <= 1.0; t += 1.0/SURF_RES_X) {

      // calculate "point" on the curve defined by the knots obtained above

      point = ...;
      display_point = Rotate(point*2.0, alfa, beta);

      SetPixelColor(screen, (int)display_point[0]+256, (int)display_point[1]+256, (color >> 8) & 0xFF, (color >> 16) & 0xFF, (color >> 24) & 0xFF);
      
    } // for 
  } // for 

} // DisplayHermit

void DisplayKnots(SDL_Surface *screen, double alfa, double beta, long color)
{
  VektorR3 point;

  for(int j = 0; j < 4; j++) {
    for(int i = 0; i < 4; i++) {

      point = Rotate(Knot[j][i]*2.0, alfa, beta);

      aalineColor(screen, (int)(point[0])-2+256, (int)(point[1])-2+256, (int)(point[0])+2+256, (int)(point[1])+2+256, color);
      aalineColor(screen, (int)(point[0])+2+256, (int)(point[1])-2+256, (int)(point[0])-2+256, (int)(point[1])+2+256, color);
      //    SetPixel(screen, (int)(P[i][0]), (int)(P[i][1]));
    } // for
  } // for
  
  DisplayHermit(screen, alfa, beta, color);
  
} // DisplayKnots

void IndexClosestPoint(int x, int y, double alfa, double beta, int &index_i, int &index_j)
{
  double   dist, min_dist = 10000000.0;
  int      index;
  VektorR3 cursor = VektorR3(x-256.0, y-256.0, 0), point;

  for(int j = 0; j < 4; j++) {
    for(int i = 0; i < 4; i++) {

      point = Rotate(Knot[j][i]*2.0, alfa, beta);

      dist = (sqr(cursor[0] - point[0])+sqr(cursor[1] - point[1]));
    
      if(min_dist > dist) {
	index_i = i;
	index_j = j;
	min_dist = dist;
      } // if
    } // for
  } // for

} // IndexClosestPoint

int main(int argc, char** argv)
{
    SDL_Surface *screen, *backup_screen;
    SDL_Event   event;
    SDL_Rect    dst_rect, full_image_rect, scrolled_rect, location;
    int         thumb_height, thumb_border_size;
    long        pixel_set = 0, index;
    bool        l_button_down = false, r_button_down = false;
    double      alfa, beta;
    VektorR3    knot, cursor;
    int         index_i, index_j;
    int         cursor_x, cursor_y;

    window_width = 512; window_height = 512;

    // interpolated starting curve

    Knot[0][0] = VektorR3(-100, -100, 50);
    Knot[0][1] = VektorR3(-50, -50, -20);
    Knot[0][2] = VektorR3(50, -50, -20);
    Knot[0][3] = VektorR3(100, -100, 50);

    // defines direction of patches start

    Knot[1][0] = VektorR3(-100, -40, 10);
    Knot[1][1] = VektorR3(-50, -40, 10);
    Knot[1][2] = VektorR3(50, -40, 10);
    Knot[1][3] = VektorR3(100, -50, 10);

    // defines direction of patches end

    Knot[2][0] = VektorR3(-100, 40, 10);
    Knot[2][1] = VektorR3(-50, 40, 10);
    Knot[2][2] = VektorR3(50, 40, 10);
    Knot[2][3] = VektorR3(100, 40, 10);

    // interpolated ending curve

    Knot[3][0] = VektorR3(-100, 100, -50);
    Knot[3][1] = VektorR3(-50, 100, 50);
    Knot[3][2] = VektorR3(50, 100, 50);
    Knot[3][3] = VektorR3(100, 100, -50);

    if(SDL_Init(SDL_INIT_VIDEO) < 0) {
	cerr << "Could not initialize SDL video" << endl;
	exit(-1);
    } // if
    atexit(SDL_Quit);

    Uint32 flags = 0;

    // flags |= SDL_FULLSCREEN;

    screen = SDL_SetVideoMode(window_width, window_height, 24, flags);

    if(!screen) {
	cerr << "could not SetVideoMode() - abort" << endl;
	exit(-1);
    } // if

    DisplayKnots(screen, alfa, beta, 0xFFFFFF);
   
    int min_x, max_x, min_y, max_y;
    int old_min_x, old_max_x, old_min_y, old_max_y;

    old_min_x = 4; old_max_x = window_width-4; old_min_y = 4; old_max_y = window_height-4;

    for(;;) {
        
      if((SDL_WaitEvent(&event) == 0) && (event.type == SDL_KEYDOWN)) 
	goto exit_app;

      switch(event.type) {
	
      case SDL_MOUSEMOTION:	      

	cursor_x = event.motion.x;
	cursor_y = event.motion.y;

	if(l_button_down) {
	  
	  DisplayKnots(screen, alfa, beta, 0x000000FF);

	  beta = (double)(event.motion.x-window_width/2)*3.19/(double)window_width;
	  alfa = (double)(event.motion.y-window_height/2)*3.19/(double)window_height;

	  DisplayKnots(screen, alfa, beta, 0xFFFFFFFF);

	  SDL_UnlockSurface(screen);
	  SDL_UpdateRect(screen, 0, 0, window_width-1, window_height-1);
	  SDL_LockSurface(screen);
	} // if

	break;
	
      case SDL_MOUSEBUTTONDOWN:
	l_button_down = true;
	break;
	
      case SDL_MOUSEBUTTONUP:
	l_button_down = false;
	break;
	
      case SDL_KEYDOWN:
	
	switch(event.key.keysym.sym) {
	  
	case '1':
	  IndexClosestPoint(cursor_x, cursor_y, alfa, beta, index_i, index_j);
	  
	  knot = Knot[index_j][index_i];
	  //	  cursor = Rotate(VektorR3(event.motion.x-256, event.motion.y-256, 0.0), alfa, beta);

	  knot[0] += 10;

	  DisplayKnots(screen, alfa, beta, 0x000000FF);

	  Knot[index_j][index_i] = knot;
	  
	  DisplayKnots(screen, alfa, beta, 0xFFFFFFFF);

	  SDL_UnlockSurface(screen);
	  SDL_UpdateRect(screen, 0, 0, window_width-1, window_height-1);
	  SDL_LockSurface(screen);
	  break;

	case '2':
	  IndexClosestPoint(cursor_x, cursor_y, alfa, beta, index_i, index_j);
	  
	  knot = Knot[index_j][index_i];
	  //	  cursor = Rotate(VektorR3(event.motion.x-256, event.motion.y-256, 0.0), alfa, beta);

	  knot[0] -= 10;

	  DisplayKnots(screen, alfa, beta, 0x000000FF);

	  Knot[index_j][index_i] = knot;
	  
	  DisplayKnots(screen, alfa, beta, 0xFFFFFFFF);

	  SDL_UnlockSurface(screen);
	  SDL_UpdateRect(screen, 0, 0, window_width-1, window_height-1);
	  SDL_LockSurface(screen);
	  break;

	case '3':
	  IndexClosestPoint(cursor_x, cursor_y, alfa, beta, index_i, index_j);
	  
	  knot = Knot[index_j][index_i];
	  //	  cursor = Rotate(VektorR3(event.motion.x-256, event.motion.y-256, 0.0), alfa, beta);

	  knot[1] += 10;

	  DisplayKnots(screen, alfa, beta, 0x000000FF);

	  Knot[index_j][index_i] = knot;
	  
	  DisplayKnots(screen, alfa, beta, 0xFFFFFFFF);

	  SDL_UnlockSurface(screen);
	  SDL_UpdateRect(screen, 0, 0, window_width-1, window_height-1);
	  SDL_LockSurface(screen);
	  break;

	case '4':
	  IndexClosestPoint(cursor_x, cursor_y, alfa, beta, index_i, index_j);
	  
	  knot = Knot[index_j][index_i];
	  //	  cursor = Rotate(VektorR3(event.motion.x-256, event.motion.y-256, 0.0), alfa, beta);

	  knot[1] -= 10;

	  DisplayKnots(screen, alfa, beta, 0x000000FF);

	  Knot[index_j][index_i] = knot;
	  
	  DisplayKnots(screen, alfa, beta, 0xFFFFFFFF);

	  SDL_UnlockSurface(screen);
	  SDL_UpdateRect(screen, 0, 0, window_width-1, window_height-1);
	  SDL_LockSurface(screen);
	  break;

	case 27:
	case 'q':
	case 'Q':
	  goto exit_app;
	  
	default:
	  break;
	} // switch
      } // switch

      //      while(SDL_PollEvent(&event) != 0)
      //	SDL_WaitEvent(&event);
      
    } // for
	    
 exit_app:

    SDL_UnlockSurface(screen);	    
    SDL_FreeSurface(screen);

    exit(0);
} // main
